config/routes.rb
Rails.application.routes.draw do
  resources :quotations do
    collection do
      get 'export'
    end
  end
  resources :categories
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "quotations#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/category.rb
class Category < ApplicationRecord
    has_many :quotations
end

app/models/quotation.rb
require 'csv'

class Quotation < ApplicationRecord
  belongs_to :category, optional: true
  attr_accessor :new_category

  def self.to_csv
    CSV.generate(headers: true) do |csv|
      csv << ["Quote", "Author", "Category", "Date"]

      all.each do |quotation|
        csv << [quotation.quote, quotation.author, quotation.category.name, quotation.date]
      end
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController
  before_action :set_category, only: %i[ show edit update destroy ]

  # GET /categories or /categories.json
  def index
    @categories = Category.all
  end

  # GET /categories/1 or /categories/1.json
  def show
  end

  # GET /categories/new
  def new
    @category = Category.new
  end

  # GET /categories/1/edit
  def edit
  end

  # POST /categories or /categories.json
  def create
    @category = Category.new(category_params)

    respond_to do |format|
      if @category.save
        format.html { redirect_to category_url(@category), notice: "Category was successfully created." }
        format.json { render :show, status: :created, location: @category }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /categories/1 or /categories/1.json
  def update
    respond_to do |format|
      if @category.update(category_params)
        format.html { redirect_to category_url(@category), notice: "Category was successfully updated." }
        format.json { render :show, status: :ok, location: @category }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @category.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /categories/1 or /categories/1.json
  def destroy
    @category.destroy

    respond_to do |format|
      format.html { redirect_to categories_url, notice: "Category was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_category
      @category = Category.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def category_params
      params.require(:category).permit(:name)
    end
end

app/controllers/quotations_controller.rb
class QuotationsController < ApplicationController
  before_action :set_quotation, only: %i[ show edit update destroy ]

  # GET /quotations or /quotations.json
  def index
    @quotations = if params[:search]
      Quotation.where("quote ILIKE ? OR author ILIKE ?", "%#{params[:search]}%", "%#{params[:search]}%")
    else
      Quotation.all
    end
  end

  # GET /quotations/1 or /quotations/1.json
  def show
  end

  # GET /quotations/new
  def new
    @quotation = Quotation.new
  end

  # GET /quotations/1/edit
  def edit
  end

  # POST /quotations or /quotations.json
  def create
    @quotation = Quotation.new(quotation_params)

    if params[:quotation][:new_category].present?
      category = Category.find_or_create_by(name: params[:quotation][:new_category])
      @quotation.category = category
    end

    respond_to do |format|
      if @quotation.save
        format.html { redirect_to quotation_url(@quotation), notice: "Quotation was successfully created." }
        format.json { render :show, status: :created, location: @quotation }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quotation.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quotations/1 or /quotations/1.json
  def update
    respond_to do |format|
      if @quotation.update(quotation_params)
        format.html { redirect_to quotation_url(@quotation), notice: "Quotation was successfully updated." }
        format.json { render :show, status: :ok, location: @quotation }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quotation.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quotations/1 or /quotations/1.json
  def destroy
    @quotation.destroy

    respond_to do |format|
      format.html { redirect_to quotations_url, notice: "Quotation was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  def export
    @quotations = if params[:search]
      Quotation.where("quote ILIKE ? OR author ILIKE ?", "%#{params[:search]}%", "%#{params[:search]}%")
    else
      Quotation.all
    end
  
    respond_to do |format|
      format.csv do
        send_data @quotations.to_csv, filename: "quotations.csv"
      end
    end
  end
  

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quotation
      @quotation = Quotation.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def quotation_params
      params.require(:quotation).permit(:author, :quote, :date, :category_id, :new_category)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/quotations_helper.rb
module QuotationsHelper
end

app/views/categories/_category.html.erb
<div id="<%= dom_id category %>">
  <p>
    <strong>Name:</strong>
    <%= category.name %>
  </p>

</div>

app/views/categories/_form.html.erb
<%= form_with(model: category) do |form| %>
  <% if category.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(category.errors.count, "error") %> prohibited this category from being saved:</h2>

      <ul>
        <% category.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/categories/edit.html.erb
<h1>Editing category</h1>

<%= render "form", category: @category %>

<br>

<div>
  <%= link_to "Show this category", @category %> |
  <%= link_to "Back to categories", categories_path %>
</div>

app/views/categories/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Categories</h1>

<div id="categories">
  <% @categories.each do |category| %>
    <%= render category %>
    <p>
      <%= link_to "Show this category", category %>
    </p>
  <% end %>
</div>

<%= link_to "New category", new_category_path %>

app/views/categories/new.html.erb
<h1>New category</h1>

<%= render "form", category: @category %>

<br>

<div>
  <%= link_to "Back to categories", categories_path %>
</div>

app/views/categories/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @category %>

<div>
  <%= link_to "Edit this category", edit_category_path(@category) %> |
  <%= link_to "Back to categories", categories_path %>

  <%= button_to "Destroy this category", @category, method: :delete %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Quotations</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/quotations/_form.html.erb
<%= form_with(model: quotation) do |form| %>
  <% if quotation.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(quotation.errors.count, "error") %> prohibited this quotation from being saved:</h2>

      <ul>
        <% quotation.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :author, style: "display: block" %>
    <%= form.text_field :author %>
  </div>

  <div>
    <%= form.label :quote, style: "display: block" %>
    <%= form.text_field :quote %>
  </div>

  <div>
    <%= form.label :date, style: "display: block" %>
    <%= form.date_field :date %>
  </div>

  <div>
    <%= form.label :category_id, style: "display: block" %>
    <%= form.collection_select :category_id, Category.all, :id, :name, prompt: 'Select a category' %>
  </div>

  <div>
    <%= form.label :new_category, "New Category" , style: "display: block" %>
    <%= form.text_field :new_category, placeholder: "Enter a new category" %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quotations/_quotation.html.erb
<div id="<%= dom_id quotation %>">
  <p>
    <strong>Author:</strong>
    <%= quotation.author %>
  </p>

  <p>
    <strong>Quote:</strong>
    <%= quotation.quote %>
  </p>

  <p>
    <strong>Date:</strong>
    <%= quotation.date %>
  </p>

  <p>
    <strong>Category:</strong>
    <%= quotation.category.name %>
  </p>

</div>

app/views/quotations/edit.html.erb
<h1>Editing quotation</h1>

<%= render "form", quotation: @quotation %>

<br>

<div>
  <%= link_to "Show this quotation", @quotation %> |
  <%= link_to "Back to quotations", quotations_path %>
</div>

app/views/quotations/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Quotations</h1>

<%= form_tag(quotations_path, method: "get") do %>
  <div class="search-block">
    <%= text_field_tag :search, params[:search], placeholder: "Search", class: "search-field" %>
    <%= submit_tag("Search", class: "search-button") %>
    <%= link_to 'Export', export_quotations_path(format: :csv), class: 'export-button' %>
  </div>
<% end %>

<%= link_to "Add new quotation", new_quotation_path, class: "add-new-button" %>

<div id="quotations">
  <% @quotations.each do |quotation| %>
    <div class="quotation-box">
    <p>
      <%= link_to quotation.quote, quotation %>
    </p>
    <p>
      <%= quotation.author %>
    </p>
    <p><%= quotation.date %></p>
    <p><%= quotation.category.name %></p>
    </p>
    </div>
  <% end %>
</div>

<style>
.search-block {
  display: flex;
  margin-bottom: 1rem;s
}

.search-field {
  border-radius: 0.5rem;
  height: 2rem;
  margin-right: 1rem;
  padding: 0.25rem 0.5rem;
  width: 25rem;
}

.search-button, .add-new-button, .export-button {
  background: #0d6efd;
  border: none;
  border-radius: 0.5rem;
  color: white;
  cursor: pointer;
  font-weight: 800;
  padding: 0.25rem 1rem;
  text-transform: uppercase;
  width: fit-content;
}

.add-new-button, .export-button {
  display: block;
  padding: 0.75rem;
  height: auto;
  text-transform: none;
  text-decoration: none;
}

.export-button {
  background: green;
  margin-left: 1rem;
  text-transform: uppercase;
}

.quotation-box {
  box-shadow: 0px 0px 10px grey;
  padding: 0.75rem;
  margin-top: 1rem;
}
</style>

app/views/quotations/new.html.erb
<h1>New quotation</h1>

<%= render "form", quotation: @quotation %>

<br>

<div>
  <%= link_to "Back to quotations", quotations_path %>
</div>

app/views/quotations/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @quotation %>

<div>
  <%= link_to "Edit this quotation", edit_quotation_path(@quotation) %> |
  <%= link_to "Back to quotations", quotations_path %>

  <%= button_to "Destroy this quotation", @quotation, method: :delete %>
</div>